--[[
   ロボカップ用プログラム
   bhv_custom_before_kick_off.cppを実装
]]
--[[require("luaLib/Geom/Vector2D_o")
require("luaLib/GameMode/GameMode") 
require("luaLib/WorldModel")]]
dofile("luaLib/Geom/Vector2D_o.lua")
dofile("luaLib/GameMode/GameMode.lua")
dofile("luaLib/WorldModel.lua")

getRoleFlg = 0
--Vector2D用のメモリ確保
point = Vector2D.new(0, 0)

function BeforeKickOff(x, y)
   point:set_x(x)
   point:set_y(y)

   --試合前
   if (getTimeCycle() == 0 and getTimeStopped() < 5) then
	doTurn(0.0)
	Neck_TurnToRelative(0.0)
	return false
   end

   --ゴール後
   if (GameModeType() == "AfterGoal" 
	and getSelfVelR() > 10) then --ここの条件式数値を変えると復帰時間を変えることできる(edit by enari)
	doTurn(180.0)
	Neck_TurnToRelative(0.0)
	return false
   end

   kickoff_side = "NEUTRAL"

   if (GameModeType() == "AfterGoal") then
	--自分たちのゴール
        if (GameModeSide() ~= ourSide()) then
	    kickoff_side = ourSide()
	else
	     --サイドチェンジ
	     if(ourSide() == "LEFT") then
	        kickoff_side = "RIGHT"
	     else
		kickoff_side = "LEFT"
	     end
        end
   else
      --役割の設定
      if (getRoleFlg == 0 
	and getbeforeRole()) then
	getRoleFlg = 1
      end

      --ハーフタイムの確認
      if (getHalfTime() > 0) then
	local half_time = getHalfTime() * 10
	local extra_half_time = getExtraHalfTime() * 10;
	local normal_time = half_time * getnrNormalHalfs()
	local extra_time = extra_half_time * getnrExtraHalfs()
	
	local time_flg = 0
	if (getTimeCycle() <= normal_time) then
	  time_flg = math.mod((getTimeCycle() / half_time), 2)
	elseif(getTimeCycle() <= normal_time + extra_time) then
	  local overtime = getTimeCycle() - normal_time 
	  time_flg = math.mod((overtime / extra_half_time), 2)
	end
        if (time_flg == 0) then
	    kickoff_side = "LEFT"
	else
	   kickoff_side = "RIGHT"
	end

      else
	kickoff_side = "LEFT"
     end
   end

   --ターゲットポイントの修正(誤差を直す)
   if (iskickoffOffside()
	and point:get_x() >= 0.0) then
	point:set_x(-0.001)
   end

   if (kickoff_side ~= ourSide()
	and point:r() < getcenterCircleR() + 0.1) then
        point:scaleVec((getcenterCircleR() + 0.5) / point:r())
   end

   local tmpr = beforekickoffLength()
   --ターゲットポイントに移動
   if (tmpr > 1.0) then
       doMove(point:get_x(), point:get_y())
       Neck_TurnToRelative(0.0)
       return true
   end

   return Scan_Field()
end

function beforekickoffLength()
    local lengthx = point:get_x() - getSelfPosX()
    local lengthy = point:get_y() - getSelfPosY()    
   
    return  math.sqrt(lengthx*lengthx + lengthy*lengthy)
end
