--[[
   オブジェクト指向型プログラミング用
]]
--require ("luaLib/Geom/Angle2D")
dofile("luaLib/Geom/Angle2D.lua")

Vector2D = {}
local ERROR_VALUE = -12345678

--インスタンス生成
function Vector2D.new(x, y)
  local obj = {x = x, y = y}
  -- メタテーブルセット
  return setmetatable(obj, {__index = Vector2D})
end

--X設定
function Vector2D.set_vec(self, x, y)
	self.x = x
	self.y = y
end

--X取得
function Vector2D.get_x(self)
	return self.x
end

--Y取得
function Vector2D.get_y(self)
	return self.y
end

--X設定
function Vector2D.set_x(self, x)
	self.x = x
end

--Y設定
function Vector2D.set_y(self, y)
	self.y = y
end

--r2
function Vector2D.r2(self)
  return self.x*self.x + self.y*self.y
end

--r
function Vector2D.r(self)
  return math.sqrt(self:r2(self))
end

--scale
function Vector2D.scale(self, scl)
  print(scl)
  self.x = self.x * scl
  self.y = self.y * scl
end

--dist
function Vector2D.dist2(self, vec)
  return math.pow(self.x - vec:get_x(), 2) +
	math.pow(self.y - vec:get_y(), 2)
end

--dist
function Vector2D.dist(self, vec)
  return math.sqrt(self:dist2(vec))
end

--polar2vector
function Vector2D.polar2vector(self, lg, theta)
    local angle = normalize(theta)
    self.x = lg * math.cos(DtoR(angle))
    self.y = lg * math.sin(DtoR(angle))
end

--isValid
function Vector2D.isValid(self)
   return ((self.x ~= ERROR_VALUE) and (self.y ~= ERROR_VALUE))
end

--ERROR
function Vector2D.ERROR(self)
   return self.set_vec(ERROR_VALUE, ERROR_VALUE)
end
