--[[
  ロボカップ用のLuaスクリプト
  dash部分をLuaで実装している
]]

dash_rate = 1.7
--Lua2Dを利用するユーザーはこの関数を利用する
function Dash(rate)
	--通常ダッシュはここで設定する
	dash_rate = rate
end

function setDashPow(recvmode)
	local dash_pow = getMaxDashPower()	--適当に設定
	local rate = dash_rate
	dash_rate = 1.7   --パラメータを戻す

	--スタミナ回復量取得
        local my_inc = getStaminaRecv()

	if (behindDefenseLine(20)) then
		return dash_pow
	elseif (recvmode) then
		--回復モードでは25以上の回復量が欲しい
		--[[dash_pow = my_inc - 25.0 --この回復量も調整した方がいいかも・・・
		if (dash_pow < 0) then
			dash_pow = 0.0;
		end]]
		dash_pow = math.max(0.0, my_inc-25.0)

		return dash_pow
	elseif (existKickableMate() and 
		getBallDist() < 20.0) then
		dash_pow = math.min(dash_pow, 
			my_inc * 1.1)
	elseif (getSelfPosX() > getOffsideLineX()) then
		return dash_pow
	else 
		dash_pow = math.max(my_inc * rate,
			dash_pow)
	end

	return dash_pow
end

function behindDefenseLine(border)
	selfpos = getSelfPosX()
	if (getDefenseLineX() > selfpos
		and selfpos < (getDefenseLineX() + border)) then
		return true
	end
	
	return false
end
