--[[
   Luaプログラム
   bhv_goalie_chase_ball.cppを実装
]]

--[[require ("luaLib/Geom/Angle2D")
require ("luaLib/Geom/Vector2D_o")
require ("luaLib/Geom/Line2D_o")

require("luaLib/Move/Tackle")]]
dofile("luaLib/Geom/Angle2D.lua")
dofile("luaLib/Geom/Vector2D_o.lua")
dofile("luaLib/Geom/Line2D_o.lua")

dofile("luaLib/Move/Tackle.lua")

agentChaseBall = GoalieChaseBall()

ChaseBall_my_int_pos = Vector2D.new(0, 0)
ChaseBall_ball_line = Line2D.new(10, 10, 20)
--ChaseBall_ball_line:set_Line2D(10, 10, 20)
ChaseBall_defend_line = Line2D.new2(0,0,0,0)
--ChaseBall_defend_line:set_Line2D2(0,-10,0,10)
ChaseBall_defend_my_inertia_final_pos = Vector2D.new(0, 0)
ChaseBall_intersection = Vector2D.new(0, 0)
ChaseBall_my_inertia_final_pos = Vector2D.new(0, 0)


--ChaseBall_intersection =  
--	ChaseBall_ball_line:intersection(ChaseBall_defend_line)
--print(ChaseBall_intersection:get_y())
function GoalieChaseBallMain()
    Tackle(0.8, 90)
    if (tackle_main()) then
       return true
    end
    
    ChaseBall_my_int_pos:set_x(getBallInertiaX(selfReachCycle()))
    ChaseBall_my_int_pos:set_y(getBallInertiaY(selfReachCycle()))

    --ボール距離誤差
    local pen_thr = getBallDist() * 0.1 + 1.0
    if (pen_thr < 1.0)then pen_thr = 1.0 end
    --
    ChaseBall_ball_line:set_Line2D(getBallPosX(), getBallPosY(), getBallVelTh())
    --print(ChaseBall_ball_line:get_a(), ChaseBall_ball_line:get_b(), ChaseBall_ball_line:get_c())
    --print(getBallVelTh().."\n")
    --守備範囲
    ChaseBall_defend_line:set_Line2D2(getSelfPosX(), -10,getSelfPosX(), 10)
     
    --ボール確保ポイントを取得
    if (ChaseBall_my_int_pos:get_x() > - pitchHalfLength() - 1.0
	and ChaseBall_my_int_pos:get_x() < ourPenaltyAreaLineX() - pen_thr
	and math.abs(ChaseBall_my_int_pos:get_y()) < penaltyAreaHalfWidth() - pen_thr) then
        save_recovery = false
	dist = ChaseBall_ball_line:dist(getSelfPosX(), getSelfPosY()) 
        if( dist < getcatchableArea()) then
	   save_recovery = true
        end
        Body_Intercept(save_recovery)
	Neck_TurnToBall()
	return true
    end

    --ボール追跡サイクル取得
    local self_goalie_min = selfReachCycle()
    local opp_min_cyc = oppReachCycle()

    --ディフェンドライン取得
    ChaseBall_intersection =  
	ChaseBall_ball_line:intersection(ChaseBall_defend_line)
    --print(ChaseBall_intersection:get_x()) --テスト完了
    if(not ChaseBall_intersection:isValid()
	or ChaseBall_ball_line:dist(getSelfPosX(), getSelfPosY()) < 
			getcatchableArea() * 0.8
	or math.abs(ChaseBall_intersection:get_y()) > 
			getgoalHalfWidth() + 3.0) then
	--キック可能な敵がいない
	if (not existKickableOpponent()) then
	   --もしキーパーが敵より早くボールをキャッチできるなら
	   if (isCatchAbleState(
		ChaseBall_my_int_pos, self_goalie_min, opp_min_cyc, pen_thr)) then
		--追跡できたかどうか
		if (Body_Intercept(false)) then
		   Neck_TurnToBall()
		   return true
		end
	   end
	   --キャッチポイント
	   --print("debug catch")
	   agentChaseBall:GoToCatchPoint(getBallPosX(), getBallPosY())
	   return true
	end
   end

   --キャッチする地点を確認
   if (getCheckCatchPoint(ChaseBall_intersection)) then
	if (Body_Intercept(false)) then
	   Neck_TurnToBall()
	   return true
	else
	   return GoalieBasicMove()
	end
   end

   --キャッチ地点がすんでいる状態での行動
   if (isStopForChase(ChaseBall_intersection)) then
	return true
   end

   --ボールを確保する
   if (getBallPosX() > -35.0) then
	--もしボールが予定の反対側なら
	if (getBallPosY() * ChaseBall_intersection:get_y() < 0.0) then
	    ChaseBall_intersection:set_y(0.0)
	else
	    local tmpy = ChaseBall_intersection:get_y()
	    ChaseBall_intersection:set_y(tmpy * 0.5)
        end
   end

   --キャッチする
   agentChaseBall:GoToCatchPoint(
	ChaseBall_intersection:get_x(), ChaseBall_intersection:get_y())
   return true
end

--キャッチポイントを確認する
function getCheckCatchPoint(intersection)
    --キャッチする前かどうか. キャッチ後のことなら確認不要(false)
    if (math.abs(intersection:get_x()) > 
		pitchHalfLength() + getcatchableArea()
	or intersection:get_x() > ourPenaltyAreaLineX() - getcatchableArea()
	or math.abs(intersection:get_y()) > 
		penaltyAreaHalfWidth() - getcatchableArea()) then
	return true
    end

    return false
end

--敵より早くボールをとれるかどうか
function isCatchAbleState(pos, self_cyc, opp_cyc, thr)
   if (self_cyc <= opp_cyc + 2
		and pos:get_x() > -pitchHalfLength() - 2.0
		and pos:get_x() < ourPenaltyAreaLineX() - thr
		and math.abs(pos:get_y()) < penaltyAreaHalfWidth() - thr) then
	return true
   end
	return false
end

--立ち止まってボールがとれるかどうか
function isStopForChase(intersection)
    --最終地点の設定
    local posX = getSelfPosX() +
	getSelfVelX() / (1.0 - getPlayerTypePlayerDecay())
    local posY = getSelfPosY() +
	getSelfVelY() / (1.0 - getPlayerTypePlayerDecay())
    ChaseBall_my_inertia_final_pos:set_x(posX)
    ChaseBall_my_inertia_final_pos:set_y(posY)
    --距離の誤差
    local dist_thr = 0.2 + getBallDist() * 0.1
    if (dist_thr < 0.5) then dist_thr = 0.5 end

    --誤差が大きくなければ正しいと判断
    if (ChaseBall_my_inertia_final_pos:dist(intersection) < dist_thr) then
	Body_StopDash(false)
	Neck_TurnToBall()
	return true
    end

    return false
end
